// Filt.cpp :   CFilt
// (C) Red User, 2004
// mailto:reduser@nm.ru

#include "stdafx.h"
#include "Filt.h"

//   strF  strL  ,     
//   ,    strF  
//   strL.
void CFilt::DelFromTo(const CString &strF, const CString &strL)
{
    m_strF = strF;
    m_strL = strL;
}

//   strB  ,      ,
//     strB,     .
void CFilt::DelFromToEnd(const CString &strB)
{
    m_strB = strB;
}

//     iMax  ,      
//   .  iMax  ,     
//     .
void CFilt::SetMaxEmpty(int iMax)
{
    m_iMaxEmpty = iMax;
}

//  .
//  pBuf -     (  ), 
//  iSize -     .
//   iSize .     ,
//   iSize .      
//  .
void CFilt::Run(LPTSTR pBuf, int &iSize) const
{
    //  
    CString strE = _T("\r\n");
    int iBMark,
        iFMark,    
        iLMark,
        iEMark,
    // ,         
        iMark = 0;

#ifdef _DEBUG
    FILETIME ftCreat,
             ftExit,
             ftKernel1,
             ftKernel2,
             ftUser1,
             ftUser2;
    ULARGE_INTEGER uiKernel1,
                   uiKernel2,
                   uiUser1,
                   uiUser2;
    GetThreadTimes(GetCurrentThread(), &ftCreat, &ftExit, &ftKernel1, &ftUser1);
#endif

#define FIND_STRE                                                                 \
    {                                                                             \
        iMark = iBMark;                                                           \
        iEMark = Find(pBuf, strE, iMark + m_strB.GetLength(), GetLast(iSize));    \
        if (iEMark > -1)                                                          \
            Delete(pBuf, iMark, iEMark - 1, iSize);                               \
        else                                                                      \
            break;                                                                \
    }

#define FIND_M_STRL                                                               \
    {                                                                             \
        iMark = iFMark;                                                           \
        iLMark = Find(pBuf, m_strL, iMark + m_strF.GetLength(), GetLast(iSize));  \
        if (iLMark > -1)                                                          \
            Delete(pBuf, iMark, iLMark + m_strL.GetLength() - 1, iSize);          \
        else                                                                      \
            break;                                                                \
    }

    for (;;)
    {
        iBMark = Find(pBuf, m_strB, iMark, GetLast(iSize));
        iFMark = Find(pBuf, m_strF, iMark, GetLast(iSize));
        if (iFMark > -1)
        {
            if (iBMark > -1)
            {
                if (iBMark < iFMark)
                    FIND_STRE
                else
                    FIND_M_STRL
            }
            else
                FIND_M_STRL
        }
        else
        {
            if (iBMark > -1)
                FIND_STRE
            else
                // iFMark < 0 && iBMark < 0
                break;
        }
    }
    if (!(iFMark < 0 && iBMark < 0))
        Delete(pBuf, iMark, GetLast(iSize), iSize);
    DelEmpty(pBuf, iSize);

#ifdef _DEBUG
    GetThreadTimes(GetCurrentThread(), &ftCreat, &ftExit, &ftKernel2, &ftUser2);
    uiKernel1.LowPart = ftKernel1.dwLowDateTime;
    uiKernel1.HighPart = ftKernel1.dwHighDateTime;
    uiKernel2.LowPart = ftKernel2.dwLowDateTime;
    uiKernel2.HighPart = ftKernel2.dwHighDateTime;
    uiUser1.LowPart = ftUser1.dwLowDateTime;
    uiUser1.HighPart = ftUser1.dwHighDateTime;
    uiUser2.LowPart = ftUser2.dwLowDateTime;
    uiUser2.HighPart = ftUser2.dwHighDateTime;
    TRACE(_T(" : %d\n"), 
        uiKernel2.QuadPart - uiKernel1.QuadPart +
        uiUser2.QuadPart - uiUser1.QuadPart);
#endif
}

//      (    ),   
//    ,  m_iMaxEmpty.  m_iMaxEmpty < 0 ( 
//  ),     .
//  pBuf -     (  ), 
//  iSize -     .
//   iSize .
void CFilt::DelEmpty(LPTSTR pBuf, int &iSize) const
{
    int iPos = 0,
    //     
        iEmpty = 0,
    //  
        iBeg = 0;
    // bEnd == TRUE,    _T('\r')
    BOOL bEnd = FALSE,
    // bSpc == TRUE,    N >= 0       _T('\r'),
    //       (,  )
         bSpc = TRUE;

    if (m_iMaxEmpty > -1)
    {
        while (iPos <= GetLast(iSize))  
        {
            switch (pBuf[iPos])
            {
            case _T(' '):   bEnd = FALSE;
                            break;
            case _T('\r'):  if (bEnd)
                                bSpc = FALSE;
                            else
                                bEnd = TRUE;
                            ASSERT(bEnd);
                            break;
            case _T('\n'):  if (bEnd)
                            {
                                if (bSpc)
                                    iEmpty++;
                                else
                                    iEmpty = 0;
                                if (iEmpty > m_iMaxEmpty)
                                {
                                    Delete(pBuf, iBeg, iPos, iSize);
                                    iPos = iBeg - 1;
                                }
                                else
                                    iBeg = iPos + 1;
                                bEnd = FALSE;
                                bSpc = TRUE;
                                break;
                            }   
                            //   _T('\n')   _T('\r'), 
                            //     
            default:        bSpc = FALSE;
                            bEnd = FALSE;
            }
            iPos++;
        }
    }
}

//    pBuf    str,   
//  iFrom    iTo.   str   , 
//    -1.   ,  
//        pBuf.    
//   -1.
int CFilt::Find(LPCTSTR pBuf, const CString& str, int iFrom, int iTo) const
{
    int iStrChar = 0;

    if (str.IsEmpty())
        return -1;
    while (iFrom <= iTo)
    {
        if (str.GetAt(iStrChar) == pBuf[iFrom])
            iStrChar++;
        else
            if (str.GetAt(0) == pBuf[iFrom])
                iStrChar = 1;
            else
                iStrChar = 0;
        if (str.GetLength() == iStrChar)
            return iFrom + 1 - iStrChar;
        iFrom++;
    }
    return -1;
}

//    pBuf ,    iFrom    iTo.
//  iSize -  .    iSize.
void CFilt::Delete(LPTSTR pBuf, int iFrom, int iTo, int& iSize) const
{
    ASSERT(iFrom <= iTo);
    memmove(&(pBuf[iFrom]), &(pBuf[iTo + 1]), iSize - (iTo + 1) * sizeof(TCHAR));
    iSize -= (iTo - iFrom + 1) * sizeof(TCHAR);
}

//      LPTSTR  iSize.
int CFilt::GetLast(int iSize) const
{
    return (iSize / sizeof(TCHAR)) - 1;
}
